from random import randint, seed, shuffle
from math import sqrt
seed(47)

def gen_random(N,E):
    return [ randint(1,E) for n in range(N) ]

def gen_distinct_random(N,E):
    answers = set()
    answers.add(1)
    answers.add(E)
    while len(answers) < N: answers.add( randint(1,E) )
    answers = list(answers)
    shuffle(answers)
    return answers

def gen_increasing(N,E):
    answers = gen_distinct_random(N,E)
    answers.sort()
    return answers

def gen_decreasing(N,E):
    answers = gen_increasing(N,E)
    answers = [1] + answers[1:-1] + [E]
    return answers

def gen_blocks(N,E):
    answers = set()
    while len(answers) < N-2: answers.add( randint(1,E) )
    answers = sorted(list(answers))
    bs = int(sqrt(N-2))

    answers2 = []
    for i in range(bs+2):
        answers2.extend( answers[bs*i:bs*i+bs][::-1] )

    return [1] + answers2 + [E]

def distort(seq,amount):
    N = len(seq)
    for rnd in range(amount):
        while True:
            x = randint(0,N-1)
            y = randint(x-5,x+5)
            if 0 <= y < N: break
        seq[x], seq[y] = seq[y], seq[x]
    return seq

def save(fname,E,seq):
    f = open(fname,'w')
    f.write('{} {}\n{}\n'.format(len(seq),E,' '.join(str(x) for x in seq)))
    f.close()

save('00.sample.a.in',50,[33,1,50,20,47])
save('00.sample.b.in',50,[1,3,3,3,3,50,1,4])
save('00.sample.c.in',50,[47,4,6,3,5,1])
save('00.sample.d.in',6,[1,2,4,3,5,6])

sizes = [ None, 10, 10, 14, 50, 100, 5000, 7000, 60000, 100000, 100000 ]

for i in range(1,11):
    N = sizes[i]
    save('{:02d}.a.in'.format(i),10**9,gen_distinct_random(N,10**9))
    save('{:02d}.b.in'.format(i),10**9,distort(gen_increasing(N,10**9),17))
    save('{:02d}.c.in'.format(i),10**9,distort(gen_decreasing(N,10**9),42))
    save('{:02d}.d.in'.format(i),10**9,distort(gen_blocks(N,10**9),23))
    save('{:02d}.e.in'.format(i),10**9,distort(gen_blocks(N,10**9),N))
    save('{:02d}.f.in'.format(i),10**9,distort(gen_increasing(N,10**9),3*N))

    if i%2 == 0:
        save('{:02d}.g.in'.format(i),N//2,gen_random(N,N//2))
        save('{:02d}.h.in'.format(i),7,gen_random(N,7))

