#include <bits/stdc++.h>
using namespace std;

int lis_nlogn(const vector<int> &A) {
    // v čase n log n vypočítame dĺžku najdlhšej rastúcej podpostupnosti v A

    // inicializujeme si C tak, aby C[0]=-inf
    // v každom okamihu si budeme pamätať len tú časť C ktorá je < inf.
    vector<int> C(1, -1);

    for (int a : A) {
        // nájdeme najmenšie i také, že C[i] >= a
        unsigned i = upper_bound( C.begin(), C.end(), a-1 ) - C.begin();
        // upravíme hodnotu C[i] na a
        if (i == C.size()) {
            C.push_back( a );
        } else {
            C[i] = a;
        }
    }
    return C.size()-1;
}

int main() {
    int N, E;
    cin >> N >> E;
    vector<int> epizody(N);
    for (int n=0; n<N; ++n) cin >> epizody[n];

    int prva = 0;
    while (prva < N && epizody[prva] != 1) ++prva;
    int posledna = N-1;
    while (posledna >= 0 && epizody[posledna] != E) --posledna;
    if (posledna < prva) {
        cout << -1 << endl;
        return 0;
    }

    vector<int> ostalo;
    for (int i=prva+1; i<posledna; ++i) {
        if (1 < epizody[i] && epizody[i] < E) {
            ostalo.push_back( epizody[i] );
        }
    }
    cout << 2 + lis_nlogn(ostalo) << endl;
}
